/*
  ok-chk01.s

  Testa se a impressao do numero de vezes que cada metodo 'e chamado
  esta correta. Este programa, ao ser executado, devera imprimir

  A::m1 : 1 times
  A::m2 : 2 times
  B::m3 : 3 times
  B::m4 : 4 times
  C::m5 : 5 times
  C::m6 : 6 times
  C::m7 : 7 times
  Program::run : 1 times

  nao necessariamente nesta ordem.

  */
   
class A
  public:
    proc m1()
      begin
      end
    proc m2()
      begin
      end
end

class B subclassOf A
  public:
    proc m3()
      begin
      end
    proc m4()
      begin
      end
end


class C
  public:
    proc m5()
      begin
      end
    proc m6()
      begin
      end
    proc m7()
      begin
      end
end



class Program
  public:
    proc run()
        var
          a1, a2 : A;
          b1, b2 : B;
          c1, c2 : C;
      begin
      a1 = A.new();
      a2 = A.new();
      b1 = B.new();
      b2 = B.new();
      c1 = C.new();
      c2 = C.new();

      a1.m1();

      a1.m2();
      a2.m2();

      b1.m3();
      b1.m3();
      b2.m3();

      b1.m4();
      b2.m4();
      b1.m4();
      b2.m4();

      c1.m5();
      c2.m5();
      c1.m5();
      c2.m5();
      c1.m5();

      c1.m6();
      c1.m6();
      c1.m6();
      c2.m6();
      c2.m6();
      c2.m6();

      c1.m7();
      c1.m7();
      c1.m7();
      c2.m7();
      c2.m7();
      c2.m7();
      c2.m7();
      end

end
