/*
  ok-ger14.s

  Teste se esta correta a geracao de codigo para variaveis de instancia
  envolvendo varias classes em uma hierarquia.
  Deve escrever

  4  3  2  1

  */
   
class A
  private:
    var k : integer;
  public:
    proc get_A() : integer      begin return self.k; end
    proc init()                 begin self.k = 1;    end
end

class B subclassOf A
  private:
    var k : integer;
  public:
    proc get_B() : integer      begin return self.k; end
    proc init()
      begin
      super.init();
      self.k = 2;
      end
end


class C subclassOf B
  private:
    var k : integer;
  public:
    proc get_C() : integer      begin return self.k; end
    proc init()
      begin
      super.init();
      self.k = 3;
      end
end


class D subclassOf C
  private:
    var k : integer;
  public:
    proc get_D() : integer      begin return self.k; end
    proc init()
      begin
      super.init();
      self.k = 4;
      end
end


class Program
  public:
    proc run()
        var
          a : A;
          b : B;
          c : C;
          d : D;
      begin
      write("The output should be :  4 3 2 1");
      d = D.new();
      d.init();
      write( d.get_D() );   // 4
      c = d;
      write( c.get_C() );   // 3
      b = c;
      write( b.get_B() );   // 2
      a = b;
      write( a.get_A() );   // 1
      end
end
