/*
   ok-ger18.s

   Testa a gerao de cdigo para forwardTo

*/

class A
   private:
      var n : integer;
   public:
      proc get() : integer
         begin
         return self.n;
         end
      proc set(n : integer)
         begin
         self.n = n;
         end
end

class C 
   public:
      proc printC()
         begin
         write("In C::printC");
         end
end

class SubC subclassOf C 
   public:
      proc printC()
         begin
         write("In SubC::printC");
         end
end
   

class D
   public:
      proc printD()
         begin
         write("In D::printD");
         end
end         
   
class SubD subclassOf D
   public:
      proc printD()
         begin
         write("In SubD::printD");
         end
end         
      

class B subclassOf A forwardsTo x, y
      private:
         var x : C;
             y : D;
      public:
         proc setX( x : C )
            begin
            self.x = x;
            end
         proc setY( y : D )
            begin
            self.y = y;
            end
         proc print()
            begin
            write(self.get());
            self.printC();
            self.printD();
            end
end

class Program
   public:
      proc run()
           var b : B;
         begin
         b = B.new();
         b.setX( C.new() );
         b.setY( D.new() );
         b.set(0);
         write("The output should be :  0, In C::printC, In D::printD, In SubC::printC, In SubD::printD  ");
         write(b.get());
         b.printC();
         b.printD();
         b.setX( SubC.new() );
         b.setY( SubD.new() );
         b.printC();
         b.printD();
         write("The output should be :  0, In SubC::printC, In SubD::printD  ");
         b.print();
         end
end

