/*
  ok-sem05.s

  Testa se o compilador aceita atribuicoes do tipo
      Classe = Subclasse
  que acontecem tambem em passagem de parametros e em retorno de valores
  de metodos (com return).
  */


class A
  private:
    var n : integer;
  public:
    proc set( pn : integer )
      begin
      self.n = pn;
      end
    proc get() : integer
      begin
      return self.n;
      end
end

class B subclassOf A
  public:
    proc set( pn : integer )
      begin
      write(pn);
      super.set(pn);
      end
end

class Program
  public:
    proc m( a : A ) : B
      begin
      a.set(0);
      return B.new();
      end
    proc p( i : integer ) : A
      begin
      if i > 0
      then
        return A.new();
      else
        return B.new();
      endif
      end
    proc run()
        var a : A;
            b : B;
      begin
      a = A.new();
      b = B.new();
      a = b;
      a.set(0);
      a = self.m(a);
      b = self.m(b);
      a = self.p(0);
      end
end
