/*
  ok-sem08.s

  Testa se o compilador aceita redefinicoes de metodos com tipos dos
  parametros iguais mas nomes diferentes.
  */


class A
  private:
    var i : integer;
  public:
    proc put( x, y : integer; ok : boolean )
      begin
      if (x > y) and ok 
      then 
        self.i = 0; 
      endif
      end
    proc get() : integer 
      begin
      return self.i;
      end
    proc set( i : integer )
      begin
      self.i = i;
      end
end


class B subclassOf A
  public:
    proc put( a, b  : integer; c : boolean )
      begin
      if (a + b < 1) and not c
      then
        write(0);
      endif
      end
end


class Program
  public:
    proc run()
        var b : B;
      begin
      b = B.new();
      b.put(1, 2, true);
      end
end
