/*
   er-sem65.s

   Testa redefinio de mtodos usando forwardTo

*/

class A
   private:
      var n : integer;
   public:
      proc get() : integer
         begin
         return self.n;
         end
      proc set(n : integer)
         begin
         self.n = n;
         end
end

class C 
   public:
      proc printC()
         begin
         write("In C::printC");
         end
end

class D
   public:
      proc printD()
         begin
         write("In D::printD");
         end
end         
   

class B subclassOf A forwardsTo x, y
      private:
         var x : C;
             y : D;
      public:
         proc setX( x : C )
            begin
            self.x = x;
            end
         proc setY( y : D )
            begin
            self.y = y;
            end
         proc printC()
            begin
            write(self.get());
            end
end

class Program
   public:
      proc run()
           var b : B;
         begin
         b = B.new();
         b.setX( C.new() );
         b.setY( D.new() );
         b.printC();
         end
end

