/*
  ok-chk02.s

  Teste se a producao das interfaces das classes esta correta. Um metodo
  chamado m_integer_returns_boolean devera ter assinatura (interface)
       proc m_integer_returns_boolean( x : integer ) : boolean
  Se o metodo se chamar print_String, a sua assinatura devera ser
       proc print_String( s : String )
  Naturalmente, o nome dos parametros nao importa.

  Note que a interface da classe B deve ser a mesma de A

  */
   
class A
  private:
    var n : integer;
        b : boolean;
        s : String;
  public:
    proc m()
      begin
      self.n = 0;
      self.b = false;
      self.s = "";
      end
    proc m_returns_boolean() : boolean
      begin
      return self.b;
      end
    proc m_integer( n : integer )
      begin
      self.n = n;
      end
    proc m_integer_boolean_String( n : integer; b : boolean; s : String )
      begin
      self.n = n;
      self.b = b;
      self.s = s;
      write(self.s);
      end
    proc m_integer_returns_boolean( n : integer ) : boolean
      begin
      if n > self.n then return false;
      else
        return self.b;
      endif
      end
    proc m_integer_boolean_String_returns_boolean(
        n : integer; b : boolean; s : String ) : boolean
      begin
      self.s = s;
      if b
      then
        return (self.n + n) > 0;
      else
        return b and self.b;
      endif
      end
end

  // A interface de B 'e a mesma de A
class B subclassOf A
end


class C
  private:
    var name : String;
        letter : boolean;
        n, time : integer;

  public:
    proc method()
      begin
      self.name = "";
      self.letter = false;
      self.n = 0;
      self.time = 0;
      end
    proc method_returns_boolean() : boolean
      begin
      return self.letter;
      end
    proc method_integer( n : integer )
      begin
      write( self.name, self.n, self.time );
      if self.letter then write("true"); else write("false"); endif
      end
    proc method_integer_boolean_String( n : integer; b : boolean; name : String )
      begin
      self.name = name;
      write(n);
      if b then write(0); else write(1); endif
      end
    proc method_integer_returns_boolean( n : integer ) : boolean
      begin
      return n > self.n;
      end
    proc method_integer_boolean_String_returns_boolean(
        n : integer; b : boolean; name : String ) : boolean
      begin
      write(self.name);
      self.name = name;
      return (n > self.n) and not b and self.letter and (self.time > 0);
      end
end


class Program
  public:
    proc run()
        var b : B;
            c : C;
      begin
      b = B.new();
      b.m();
      c = C.new();
      c.method();
      end
end
