/*
   ok-chk07.s

   Este programa 'e usado para testar o "refactoring"  "extract class".
   Note que o codigo resultante do refactoring pode NAO compilar.
   'E o caso deste exemplo.

*/

class Person
  private:
    var course : String;
        number, age : integer;
        name : String;
  public:
    proc getCourse() : String
      begin
      return self.course;
      end
    proc setCourse( course : String )
      begin
      self.course = course;
      end
    proc getNumber() : integer
      begin
      return self.number;
      end
    proc setNumber( number : integer )
      begin
      self.number = number;
      end
    proc init( name : String; age : integer )
      begin
      self.name =name;
      self.age = age;
      end
    proc getName() : String
      begin
      return self.name;
      end
    proc getAge() : integer
      begin
      return self.age;
      end
    proc print()
      begin
      write("Name = ", self.name);
      write("Age = " , self.age);
      end
end


class Group
  private:
    var first, second : Person;
  public:
    proc set( first, second : Person )
       begin
       self.first = first;
       self.second = second;
       end
    proc getFirst() : Person
       begin
       return self.first;
       end
    proc getSecond() : Person
       begin
       return self.second;
       end
    proc print()
       begin
       write("First: ", self.first.getName());
       write("Second: ", self.second.getName());
       end
end


class University
  private:
    var name : String;
        numberOfStudents : integer;
        city : String;
  public:
    proc init( name, city : String; numberOfStudents : integer )
      begin
      self.name = name;
      self.city = city;
      self.numberOfStudents = numberOfStudents;
      end
    proc print()
      begin
      write(self.name);
      write(self.city);
      write(self.numberOfStudents);
      end
end


class Program
  public:
    proc run()
        var s : University;
            joao, maria : Person;
            g : Group;
      begin
      s = University.new();
      s.init("UFSCar", "Sao Carlos", 7000);
      s.print();
      joao = Person.new();
      joao.init("Joao", 21);
      joao.setCourse("EnC");
      joao.setNumber(6729);
      maria = Person.new();
      maria.init("Maria", 20);
      maria.setCourse("Fisioterapia");
      maria.setNumber(8607);

      joao.print();
      maria.print();
      g = Group.new();
      g.set(joao, maria);
      g.print();
      end
end