/*
  ok-ger01.s

  Cada teste ok-ger*.s possui uma instrucao write,
  executada antes de qualquer outra, que imprime
  a saida esperada do programa. 
     Para conferir se o seu programa esta gerando
  codigo correto, faca o seguinte: chame o seu
  compilador para gerar codigo em C (ou Java) a
  partir de ok-ger01.s. Compile o codigo com um
  compilador C e o execute. Esta execucao devera 
  imprimir na tela 
     The output should be :  7  0  1  2  3  4  5  6  7
     7  0  1  2  3  4  5  6  7
  E possivel que o numero de espacos seja diferente do 
  mostrado acima. A primeira linha foi impressa pelo
  comando 
      write("The output should be :  7  0  1  2  3  4  5  6  7");
  e a segunda linha pelos comandos write espalhados
  pelo programa Simples. Lembre-se de gerar o codigo
     puts("uma string");
  em C para o comando Simples
     write("uma string");

  Se as duas saidas forem diferentes, o seu compilador
  esta gerando codigo errado. Se estiver, o seu programa
  podera escrever algo como 
     7  0  1  3  4  5  7


  Este programa, ok-ger01.s, testa se o codigo para os operadores
  de comparacao sao gerados corretamente.
  */

class A
  public:
    proc m()
      begin
      write(7);
      if 1 > 0
      then
        write(0);
      endif
      if 1 >= 0
      then
        write(1);
      endif
      if 1 <> 0
      then
        write(2);
      endif
      if 0 < 1
      then
        write(3);
      endif
      if 0 <= 1
      then
        write(4);
      endif
      if 0 == 0
      then
        write(5);
      endif
      if 0 >= 0
      then
        write(6);
      endif
      if 0 <= 0
      then
        write(7);
      endif

      if 1 == 0
      then
        write(18);
      endif
      if 0 > 1
      then
        write(10);
      endif
      if 0 >= 1
      then
        write(11);
      endif
      if 0 <> 0
      then
        write(12);
      endif
      if 1 < 0
      then
        write(13);
      endif
      if 1 <= 0
      then
        write(14);
      endif
      
      end
end

class Program
  public:
    proc run()
        var a : A;
      begin
      write("The output should be :  7  0  1  2  3  4  5  6  7");
      a = A.new();
      a.m();
      end
end
